

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">

  <meta name="viewport" content="width=device-width, initial-scale=1.0">

  <title>Asymmetric Key Services &mdash; TISCI User Guide</title>




    <link rel="shortcut icon" href="../_static/favicon.ico"/>












    <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />



    <link rel="stylesheet" href="../_static/theme_overrides.css" type="text/css" />



        <link rel="index" title="Index"
              href="../genindex.html"/>
        <link rel="search" title="Search" href="../search.html"/>
    <link rel="top" title="TISCI User Guide" href="../index.html"/>
        <link rel="up" title="Chapter 6: Topic User Guides" href="index.html"/>
        <link rel="prev" title="Keystore Provisioning" href="keystore_provision.html"/>


  <script src="../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">
  <header id="tiHeader">
    <div class="top">
      <ul>
        <li id="top_logo">
          <a href="http://www.ti.com">
            <img src="../_static/img/ti_logo.png"/>
          </a>
        </li>
      </ul>
    </div>
    <div class="nav"></div>
  </header>
  <div class="wy-grid-for-nav">


    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">



            <a href="../index.html" class="icon icon-home"> TISCI



          </a>




              <div class="version">
                19.07.00
              </div>




<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>


        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">



                <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../1_intro/index.html">Chapter 1: Introduction</a></li>
<li class="toctree-l1"><a class="reference internal" href="../2_tisci_msgs/index.html">Chapter 2: TISCI Message Documentation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../3_boardcfg/index.html">Chapter 3: Board Configuration</a></li>
<li class="toctree-l1"><a class="reference internal" href="../4_trace/index.html">Chapter 4: Interpreting Trace Data</a></li>
<li class="toctree-l1"><a class="reference internal" href="../5_soc_doc/index.html">Chapter 5: SoC Family Specific Documentation</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="index.html">Chapter 6: Topic User Guides</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="secure_boot_signing.html">Signing binaries for Secure Boot</a></li>
<li class="toctree-l2"><a class="reference internal" href="keystore_provision.html">Keystore Provisioning</a></li>
<li class="toctree-l2 current"><a class="current reference internal" href="#">Asymmetric Key Services</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#introduction">Introduction</a></li>
<li class="toctree-l3"><a class="reference internal" href="#data-format">Data Format</a></li>
<li class="toctree-l3"><a class="reference internal" href="#with-rsa-keys">With RSA Keys</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#rsa-encryption-primitive-rsaep">RSA Encryption Primitive (RSAEP)</a></li>
<li class="toctree-l4"><a class="reference internal" href="#rsa-decryption-primitive-rsadp">RSA Decryption Primitive (RSADP)</a></li>
<li class="toctree-l4"><a class="reference internal" href="#rsa-signature-primitive-rsasp1">RSA Signature Primitive (RSASP1)</a></li>
<li class="toctree-l4"><a class="reference internal" href="#rsa-verification-primitive-rsavp1">RSA Verification Primitive (RSAVP1)</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#with-ec-keys">With EC Keys</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#ecdsa-sign">ECDSA Sign</a></li>
<li class="toctree-l4"><a class="reference internal" href="#ecdsa-verify">ECDSA Verify</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#return-failures">Return failures</a></li>
<li class="toctree-l3"><a class="reference internal" href="#references">References</a></li>
</ul>
</li>
</ul>
</li>
</ul>



        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">


      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../index.html">TISCI</a>
      </nav>



      <div class="wy-nav-content">
        <div class="rst-content">






<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../index.html">Docs</a> &raquo;</li>

          <li><a href="index.html">Chapter 6: Topic User Guides</a> &raquo;</li>

    <li>Asymmetric Key Services</li>
      <li class="wy-breadcrumbs-aside">



      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">

  <div class="section" id="asymmetric-key-services">
<h1>Asymmetric Key Services<a class="headerlink" href="#asymmetric-key-services" title="Permalink to this headline">¶</a></h1>
<p>This document describes the asymmetric key services available in System Firmware.</p>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>Asymmetric key services refer to the foundational operations on which all public
key cryptography schemes are built:</p>
<ol class="arabic simple">
<li>Encrypt a message with a public key</li>
<li>Decrypt a message with a private key</li>
<li>Sign (encrypt) a message with a private key</li>
<li>Verify (decrypt) a signature with a public key</li>
</ol>
<p>System Firmware provides APIs to perform these operations through a Public Key
Accelerator (PKA) module. The remainder of the document describes the details of
these operations for RSA and Elliptic Curve algorithms.</p>
<p>For all of the operations, we assume that the required keys are already present
in the keystore.</p>
</div>
<div class="section" id="data-format">
<h2>Data Format<a class="headerlink" href="#data-format" title="Permalink to this headline">¶</a></h2>
<p>Like the key parameters, all input and output vectors use the <a class="reference internal" href="keystore_provision.html#bigint-data-format"><span class="std std-ref">BIGINT
format</span></a> supported by PKA. The host is responsible for
supplying the input data in this format and must extract output data
accordingly.</p>
</div>
<div class="section" id="with-rsa-keys">
<h2>With RSA Keys<a class="headerlink" href="#with-rsa-keys" title="Permalink to this headline">¶</a></h2>
<p>System Firmware provides API’s directly corresponding to the Cryptographic Primitives
specified in Section 5 of RFC8017 [1]. This allows user to implement the
encryption and signature schemes specified in RFC8017 while maintaining key
secrecy using System Firmware.</p>
<p>Note that the cryptographic primitives provide fundamental operations on which
higher-level encryption and signature schemes may be implemented. There is no
assumption made on format or padding of the data nor on what the contents of the
data represent.</p>
<div class="section" id="rsa-encryption-primitive-rsaep">
<h3>RSA Encryption Primitive (RSAEP)<a class="headerlink" href="#rsa-encryption-primitive-rsaep" title="Permalink to this headline">¶</a></h3>
<p>To use RSAEP, the user invokes System Firmware API with the following arguments.</p>
<ol class="arabic simple">
<li>Index in the keystore containing the public key to be used for encryption.</li>
<li>Memory location containing the plaintext data.</li>
<li>Memory location to which the encrypted output ciphertext data must be
copied.</li>
</ol>
<p>System Firmware copies the plaintext data into DMSC internal memory, encrypts it
with the specified public key, and copies the ciphertext into the specified
output location.</p>
<div class="figure">
<a class="reference internal image-reference" href="../_images/rsa_encrypt_primitive.svg"><img alt="../_images/rsa_encrypt_primitive.svg" src="../_images/rsa_encrypt_primitive.svg" width="70%" /></a>
</div>
</div>
<div class="section" id="rsa-decryption-primitive-rsadp">
<h3>RSA Decryption Primitive (RSADP)<a class="headerlink" href="#rsa-decryption-primitive-rsadp" title="Permalink to this headline">¶</a></h3>
<p>To use RSADP, the user invokes System Firmware API with the following arguments.</p>
<ol class="arabic simple">
<li>Index in the keystore containing the private key to be used for decryption.</li>
<li>Memory location containing the ciphertext data.</li>
<li>Memory location to which the decrypted plaintext data must be copied.</li>
</ol>
<p>System Firmware copies the ciphertext into DMSC internal memory, decrypts it with the
specified private key, and copies the decrypted plaintext data into the
specified output location.</p>
<div class="figure">
<a class="reference internal image-reference" href="../_images/rsa_decrypt_primitive.svg"><img alt="../_images/rsa_decrypt_primitive.svg" src="../_images/rsa_decrypt_primitive.svg" width="70%" /></a>
</div>
</div>
<div class="section" id="rsa-signature-primitive-rsasp1">
<h3>RSA Signature Primitive (RSASP1)<a class="headerlink" href="#rsa-signature-primitive-rsasp1" title="Permalink to this headline">¶</a></h3>
<p>To use RSASP1, the user invokes System Firmware API with the following arguments.</p>
<ol class="arabic simple">
<li>Index in the keystore containing the private key to be used for signing.</li>
<li>Memory location containing the plaintext data.</li>
<li>Memory location to which the generated ciphertext data (signature) must be
copied.</li>
</ol>
<p>System Firmware copies the message hash into DMSC internal memory, performs the signing
operation with the private key, and copies the signature into the specified
output location.</p>
<div class="figure">
<a class="reference internal image-reference" href="../_images/rsa_signature_primitive.svg"><img alt="../_images/rsa_signature_primitive.svg" src="../_images/rsa_signature_primitive.svg" width="70%" /></a>
</div>
</div>
<div class="section" id="rsa-verification-primitive-rsavp1">
<h3>RSA Verification Primitive (RSAVP1)<a class="headerlink" href="#rsa-verification-primitive-rsavp1" title="Permalink to this headline">¶</a></h3>
<p>To use RSAVP1, the user invokes System Firmware API with the following arguments.</p>
<ol class="arabic simple">
<li>Index in the keystore containing the public key to be used for the verify
operation.</li>
<li>Memory location containing the signature.</li>
<li>Memory location to which the plaintext data must be copied.</li>
</ol>
<p>System Firmware copies the signature into DMSC internal memory and performs the verify
operation using the specified public key. It copies the generated message hash
to the specified output location.</p>
<div class="figure">
<a class="reference internal image-reference" href="../_images/rsa_verify_primitive.svg"><img alt="../_images/rsa_verify_primitive.svg" src="../_images/rsa_verify_primitive.svg" width="70%" /></a>
</div>
</div>
</div>
<div class="section" id="with-ec-keys">
<h2>With EC Keys<a class="headerlink" href="#with-ec-keys" title="Permalink to this headline">¶</a></h2>
<p>System Firmware supports API’s necessary to implement ECDSA sign and verify operations
as per [2] below. In both the operations, calculation of the hash of the message
is required to be performed before invoking the API. This allows the System Firmware
API’s to be independent of the hash algorithm chosen.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">According to [3] below, it is recommended to choose a hash with bit length
equal to the security strength associated with the bit length of the curve’s
group order <cite>n</cite>. If the length of the hash is greater than the bit length of
<cite>n</cite> then the user must truncate to select only the leftmost n bits (that is,
the <cite>n</cite> MSBs of the BIGINT representation of the hash) or else System Firmware
operation will fail. A hash with bit length less than <cite>n</cite> will effectively
reduce the strength of the security of the digital signature to the
strength of the hash function, at best.</p>
</div>
<div class="section" id="ecdsa-sign">
<h3>ECDSA Sign<a class="headerlink" href="#ecdsa-sign" title="Permalink to this headline">¶</a></h3>
<p>For creating a ECDSA signature of a message, the user</p>
<ol class="arabic simple">
<li>Calculates the hash of the message with a desired algorithm.</li>
<li>Invokes the ECDSA sign API with the below arguments.<ol class="arabic">
<li>the hash of the message,</li>
<li>the slot number of the private key to be used for signing in the keystore
and</li>
<li>the memory location where the signature of the message must be placed.</li>
</ol>
</li>
<li>System Firmware copies the hash of the message into DMSC internal memory, calculates
the signature of the message using the specified private key and copies the
signature to the specified memory location.</li>
</ol>
<div class="figure">
<a class="reference internal image-reference" href="../_images/ecdsa_sign.svg"><img alt="../_images/ecdsa_sign.svg" src="../_images/ecdsa_sign.svg" width="70%" /></a>
</div>
</div>
<div class="section" id="ecdsa-verify">
<h3>ECDSA Verify<a class="headerlink" href="#ecdsa-verify" title="Permalink to this headline">¶</a></h3>
<p>For verifying a message with ECDSA signature, the user</p>
<ol class="arabic simple">
<li>Calculates the hash of the message using the algorithm specified by the
sender of the message.</li>
<li>Invokes the System Firmware ECDSA verify API with the below arguments<ol class="arabic">
<li>the hash of the message,</li>
<li>the slot number of the senders public key in the keystore and</li>
<li>the signature of the message.</li>
</ol>
</li>
<li>System Firmware copies the hash and signature into DMSC internal memory, verifies the
signature and hash against the public key. The pass/fail status is returned
in the response message.</li>
</ol>
<div class="figure">
<a class="reference internal image-reference" href="../_images/ecdsa_verify.svg"><img alt="../_images/ecdsa_verify.svg" src="../_images/ecdsa_verify.svg" width="70%" /></a>
</div>
</div>
</div>
<div class="section" id="return-failures">
<h2>Return failures<a class="headerlink" href="#return-failures" title="Permalink to this headline">¶</a></h2>
<p>For all of the above functions, System Firmware will only return an ACK when successful
or a NACK if unsuccessful.  Possible reasons for a NACK can be one or more of
the following:</p>
<ul class="simple">
<li>ID of the host requesting access to the key to be used by the primitive
operation does not match the Host ID specified for that key slot</li>
<li>Key slot requested does not hold a valid key</li>
<li>Type of operation requested does not have the corresponding usage
flag set for the specified key slot</li>
<li>Host is requesting operation on a data in memory which they do not own
(UDMA transfer to/from DMSC internal memory will fail)</li>
<li>Key parameters are not valid and cause PKA operation to fail (System Firmware does not
enforce that the user provides valid key parameters otherwise)</li>
<li>Input data is too large<ul>
<li>For RSA - size of the input data is larger than the modulus</li>
<li>For ECDSA - length of the hash data is larger than the group order</li>
</ul>
</li>
</ul>
</div>
<div class="section" id="references">
<h2>References<a class="headerlink" href="#references" title="Permalink to this headline">¶</a></h2>
<ol class="arabic simple">
<li>PKCS #1: RSA Cryptography Specifications Version 2.2,
<a class="reference external" href="https://tools.ietf.org/html/rfc8017">https://tools.ietf.org/html/rfc8017</a></li>
<li>Standards for Efficient Cryptography Group, “Elliptic Curve Cryptography”,
SEC 1, Version 2.0, May 2009 <a class="reference external" href="http://www.secg.org/sec1-v2.pdf">http://www.secg.org/sec1-v2.pdf</a></li>
<li>Digital Signature Standard (DSS), FIPS PUB 186-4
<a class="reference external" href="https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.186-4.pdf">https://nvlpubs.nist.gov/nistpubs/FIPS/NIST.FIPS.186-4.pdf</a></li>
</ol>
</div>
</div>


           </div>
          </div>
          <footer>

    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">


        <a href="keystore_provision.html" class="btn btn-neutral" title="Keystore Provisioning" accesskey="p"><span class="fa fa-arrow-circle-left"></span> Previous</a>

    </div>


  <hr/>

  <div role="contentinfo">
    <p>
      <a href="http://www.ti.com/corp/docs/legal/copyright.shtml">&copy; Copyright 2016-2019</a>, Texas Instruments Incorporated. All rights reserved. <br>
      <a href="http://www.ti.com/corp/docs/legal/trademark/trademrk.htm">Trademarks</a> | <a href="http://www.ti.com/corp/docs/legal/privacy.shtml">Privacy policy</a> | <a href="http://www.ti.com/corp/docs/legal/termsofuse.shtml">Terms of use</a> | <a href="http://www.ti.com/lsds/ti/legal/termsofsale.page">Terms of sale</a>

    </p>
  </div>

</footer>

        </div>
      </div>

    </section>

  </div>





    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../',
            VERSION:'19.07.00',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../_static/jquery.js"></script>
      <script type="text/javascript" src="../_static/underscore.js"></script>
      <script type="text/javascript" src="../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

    <script src="http://www.ti.com/assets/js/headerfooter/analytics.js" type="text/javascript" charset="utf-8"></script>





    <script type="text/javascript" src="../_static/js/theme.js"></script>




  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
        });

      var menuHeight = window.innerHeight;

      var contentOffset = $(".wy-nav-content-wrap").offset();
      var contentHeight = $(".wy-nav-content-wrap").height();
      var contentBottom = contentOffset.top + contentHeight;

      function setNavbarTop() {
          var scrollTop = $(window).scrollTop();
          var maxTop = scrollTop + menuHeight;

          // If past the header
          if (scrollTop > contentOffset.top && maxTop < contentBottom) {
            stickyTop = scrollTop - contentOffset.top;
          } else if (maxTop > contentBottom) {
            stickyTop = scrollTop - contentOffset.top - (maxTop - contentBottom);
          } else {
            stickyTop = 0;
          }

          $(".wy-nav-side").css("top", stickyTop);
      }

      $(document).ready(function() {
        setNavbarTop();
        $(window).scroll(function () {
          setNavbarTop();
        });

        $('body').on("mousewheel", function () {
            // Remove default behavior
            event.preventDefault();
            // Scroll without smoothing
            var wheelDelta = event.wheelDelta;
            var currentScrollPosition = window.pageYOffset;
            window.scrollTo(0, currentScrollPosition - wheelDelta);
        });
      });
  </script>


</body>
</html>